<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

class Config_Load extends AjaxRequest {

	function init()	{
		//$lines=file("/etc/asl/".$this->req["filename"]);
		$lines=file("/etc/asl/config");
		
		foreach ($lines AS $k=>$v) {
			$v=trim($v);
			// comment line
			if (substr($v,0,1)=="#") {
				$this->data[]=$this->add_comment($v);
			}
			else if (empty($v) || ord(substr($v,0,1))==10) {
				$this->data[]=$this->add_spacer();
			}
			else {
				$text="";
				$parts=split("=",$v);
				$fieldname=$parts[0];
				
				if (file_exists("../help/config/".$fieldname.".txt")) {
					$help=file_get_contents("../help/config/".$fieldname.".txt");
				}
				else {
					$help="No help is available for this element.";
				}
				// boolean
				if (strtolower($parts[1])=="no" || strtolower($parts[1])=="yes") {
					if ($parts[1]=="no") {$fieldvalue=0;}
					else				 {$fieldvalue=1;}
					$this->data[]=$this->add_boolean($fieldname,$fieldvalue,$help);
				}
				// string
				else if (substr($parts[1],0,1)==chr(34)) {
					$fieldvalue=str_replace(chr(34),"",$parts[1]);
					if ($fieldvalue=="") {$fieldvalue=" ";}
					$this->data[]=$this->add_string($fieldname,$fieldvalue,$help);
				}
				else {}
			}
		}
	}
	
	function add_comment($line) {$tmp=array("type"=>"header","text"=>$line); return $tmp;}
	function add_spacer() {$tmp=array("type"=>"spacer","text"=>"spacer"); return $tmp;}
	function add_boolean($fieldname,$fieldvalue,$help) {
		$tmp=array("type"=>"boolean","text"=>"null","fieldname"=>$fieldname,"fieldvalue"=>$fieldvalue,"help"=>htmlentities($help));
		return $tmp;
	}
	function add_string($fieldname,$fieldvalue,$help) {
		$tmp=array("type"=>"string","text"=>"null","fieldname"=>$fieldname,"fieldvalue"=>$fieldvalue,"help"=>htmlentities($help));
		return $tmp;
	}
}
?>
