<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

include_once("/etc/asl/web.conf");


/*
display	dashboard
filename	/20080611/20080611-1109/20080611-110906-bREAAlKl8i4AAF2FpVUAAAAJ
ip	70.87.64.234
logname	/var/log/httpd/audit_log
sig_id	360000
sub	sec_event_detail
timestamp	1213204124500
vhost	www.atomicorp.com
*/


class DB_SecEvent extends AjaxRequest {
	var $log_path="/var/ossec/logs/alerts/";
	var $log_name="alerts.log";
	var $al_path="";
	//var $ignore="5706";
	var $msg_length=84;
	var $dns="http://whois.domaintools.com";
	var $counter=0;
	var $arrOut=array();
	var $data_tmp=array();
	var $test="";

	function init() {
		if (!isset($_SESSION["asl_last_line"])) {$_SESSION["asl_last_line"]=0;}
		
		$display="dashboard";
		$sub="sec_event_detail";

		// get data from database
		if (ALERTS_USE_DB==1) 	{$this->get_data_from_db();}
		// get data from log file
		else 					{
			$this->get_data_from_file();
			$this->filter_data();
		}
	}

	function dec2ip($dec) {
		if ($dec<0) {$dec=(double) 4294967296+dec;}
		if ($dec>16777215) {
			$ip=$dec-(intval($dec/256)*256);
			$dec=(double) intval($dec/256);
		}
		else {$ip="0";}
		if ($dec>65535) {
			$ip=($dec-(intval($dec/256)*256)).".".$ip;
			$dec=(double) intval($dec/256);
		}
		else {$ip="0.".$ip;}
		if ($dec>255) {
			$ip=($dec-(intval($dec/256)*256)).".".$ip;
			$dec=(double) intval($dec/256);
		}
		else {$ip="0.".$ip;}
		$ip=$dec.".".$ip;
		return $ip;
	}
	
	function ip2dec($ip)	{
		$parts=explode(".",$ip);
		$dec = ((((($parts[0] * 256 + $parts[1]) * 256) + $parts[2]) * 256) + $parts[3]);
		return $dec;
	}
	
	function fix_location($in) {
		$tmp=split("->",$in);
		return $tmp[1];
	}

	//function to validate ip address format in php by Roshan Bhattarai(http://roshanbh.com.np)
	function validateIpAddress($ip_addr) {
		//first of all the format of the ip address is matched
		if(preg_match("/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/",$ip_addr))	{
			//now all the intger values are separated
			$parts=explode(".",$ip_addr);
			//now we need to check each part can range from 0-255
			foreach($parts as $ip_parts) {
				if(intval($ip_parts)>255 || intval($ip_parts)<0) {
					return false; //if number is not within range of 0-255
				}
			}
			return true;
		}
		else {
			return false; //if format of ip address doesn't matches
		}
	}

	function parse_log($logentry,$logname,$id) {
		if ($id=="") {$ids="";}
		else		{$ids="&id=".$id;}
		
		$tmp=array();
		$m_pattern="/.*\[modsecurity\] \[client (\S+)\] \[domain (\S+)\] \[(\d+)\] \[(.*)\]  (.*)/";
		if (preg_match($m_pattern,$logentry,$logline)) {
			$tmp["type"]="split";
			$tmp["client"]=$logline[1];
			$tmp["domain"]=$logline[2];
			$tmp["error_code"]=$logline[3];
			$tmp["logfile"]=$logline[4];
			
			$tmp["logentry"]=$tmp["domain"]." || ".$tmp["client"];
			
			//$e_pattern="/\[file \"(.*)\"\] \[line \"(.*)\"\] \[id \"(.*)\"\] \[msg \"(.*)\"\] \[severity \"(.*)\"\] (.*)/";
			// close	$e_pattern="/\[file \"(.*)\"\] \[line \"(.*)\"\] \[id \"(\d+)\"\] \[msg \"(.*)\"\] \[severity \"(.*)\"\] (.*)/";
			// no		$e_pattern="/\[file \"(.*)\"\] \[line \"(.*)\"\] \[id \S+(\d+)\S+\] \[msg \"(.*)\"\] \[severity \"(.*)\"\] (.*)/";
			// yes
			$e_pattern="/\[file \"(.*)\"\] \[line \"(.*)\"\] \[id .*(\d\d\d\d\d\d).*\] \[msg \"(.*)\"\] \[severity \"(.*)\"\] (.*)/";
			// close matches the data ones
                        //$e_pattern="/\[file \"(.*)\"\] \[line \"(.*)\"\] \[id .*(\d\d\d\d\d\d).*\] \[msg \"(.*)\"\] \[data \".*\"\] \[severity \"(.*)\"\] (.*)/";


			if (preg_match($e_pattern,$logline[5],$e_logline)) {
				$rule_filename=$e_logline[1];

				// the regex for this needs to be tuned, sometimes it cant parse correctly
				$rule=$e_logline[3];

				$rule_msg=htmlspecialchars($e_logline[4]);
				$rule_severity=$e_logline[5];

				$tmp["logentry"]=$tmp["logentry"]." || ".$rule_msg;
				
				$tmp["icon"]="<a href=javascript:tabs[0].page.event_reader('".htmlentities("lib/php/_ajax_entry.php?display=dashboard&sub=sec_event_detail&filename=".$this->al_path.$tmp["logfile"]."&vhost=".$tmp["domain"]."&logname=".$logname."&ip=".$tmp["client"])."&sig_id=".$rule.$ids."');><img src=images/appfw.png></a>";
			}
			else {
				$tmp["icon"]="<a href=javascript:tabs[0].page.event_reader('".htmlentities("lib/php/_ajax_entry.php?display=dashboard&sub=sec_event_detail&filename=".$this->al_path.$tmp["logfile"]."&vhost=".$tmp["domain"]."&logname=".$logname."&ip=".$tmp["client"]).$ids."');><img src=images/appfw.png></a>";
			}
		}
		else {
			$tmp["type"]="single";

			// FILE INTEGRITY
			$f_pattern="/^Integrity checksum.*'(\S+)'/";
			if (preg_match($f_pattern,$logentry,$logline)) {
				//$logentry=" <a href=javascript:tabs[0].page.get_filecheck_detail('".htmlentities("lib/php/_filedetail.php?filename=$foo[6]&size=$foo[0]&permissions=$foo[1]&owner=$foo[2]&md5sum=$foo[3]&date=$foo[5]")."');>$foo[6]</a>";
				$tmp["icon"]="<img src='images/filecheck.png'>";
			}
			else {
				$tmp["icon"]="<img src='images/red.png'>";
			}
			
			// Clear timestamps from logs.  We capture this from OSSEC
			//Jun 20 00:01:44
				$patterns[0]="/^\w+\s+\d+ \d+:\d+:\d+/";
			//[Wed Jun 20 06:11:19 2007]
				$patterns[1]="/\[\w+ \w+ \d+ \d+:\d+:\d+ \d+\]/";
			//[20/Jun/2007:11:34:15 -0400] 
				$patterns[2]="/- - \[\d+\/\w+\/\d+:\d+:\d+:\d+ -\d+\]/";

			$replace="";
			$logentry=preg_replace($patterns,$replace,$logentry);
			
			// shorten the logentry line
			$logentry=substr($logentry,0,$this->msg_length);

			// Fixups
			$tmp["logfile"]="syscheck";
			$tmp["client"]="client";
			$tmp["domain"]="local";

			// HTML it
			$tmp["logentry"]=htmlentities($logentry);
		}
		
		return $tmp;
	}

	function get_data_from_db()	{
		$last="";

		// time filter		
		if ($this->req["time_start"]=="hh:mm[:ss]" || $this->req["time_start"]=="") {$ts_flag=0;}
		else {
			$ts_flag=1;
			$ts=strtotime(date("Y-m-d",time())." ".$this->req["time_start"]);
		}
		if ($this->req["time_end"]=="hh:mm[:ss]" || $this->req["time_end"]=="") {$te_flag=0;}
		else {
			$te_flag=1;
			$te=strtotime(date("Y-m-d",time())." ".$this->req["time_end"]);
		}
		if ($ts_flag==0 && $te_flag==1) {$tstring="AND a.timestamp<='".$te."' ";}
		if ($ts_flag==1 && $te_flag==1)	{$tstring="AND a.timestamp BETWEEN '".$ts."' AND '".$te."' ";}
		if ($ts_flag==1 && $te_flag==0) {$tstring="AND a.timestamp>='".$ts."' ";}
		if ($ts_flag==0 && $te_flag==0) {$tstring="";}
		
		// domain filter
		if (empty($this->req["domain"])) {
			$ipstring="";
			$dstring="";
		}
		else {
			$z=$this->validateIpAddress($this->req["domain"]);
			$this->test=$z;
			if ($z) {
				$ipstring="AND a.src_ip='".$this->ip2dec($this->req["domain"])."' ";
				$dstring="";
				$this->test.=" | ".$this->req["domain"]." | ".$this->dec2ip($this->ip2dec($this->req["domain"]));
			}
			else {
				$ipstring="";
				$dstring="AND d.full_log LIKE '%".$this->req["domain"]."%' ";
				//$dstring="AND (s.hostname='".$this->req["domain"]."' OR s.hostname LIKE '%".$this->req["domain"]."%') ";
				
			}
		}
		$this->test.=" | ".$ipstring." | ".$dstring;
		
		
		$dbc=mysql_connect(DB_HOST,DB_USER,DB_PASS);
		$db=mysql_select_db(DB_NAME,$dbc);
		
		$sql="SELECT a.id,a.rule_id,a.timestamp,a.src_ip,a.dst_ip,a.src_port,a.dst_port,".
				"s.hostname,l.name AS location,d.full_log,sig.level,sig.description ".
				"FROM alert a, server s, location l, data d, signature sig ".
				"WHERE ".
				"a.id>".$_SESSION["asl_last_line"]." ".
				"AND s.id=a.server_id ".
				"AND (l.id=a.location_id AND l.server_id=a.server_id) ".
				"AND (d.id=a.id AND d.server_id=a.server_id) ".
				"AND sig.rule_id=a.rule_id ".
				"AND sig.level>='".$this->req["level"]."' ".
				$tstring.
				$ipstring.
				$dstring.
				"ORDER BY a.id DESC LIMIT 50";
		$q=mysql_query($sql);
		
		while ($r=mysql_fetch_assoc($q)) {
			$last=$r["id"];
			
			// get filename from data.full_log
			$logname=$this->fix_location($r["location"]);
			$z=$this->parse_log($r["full_log"],$logname,$r["id"]);

			//if (substr($z["icon"],0,4)=="<img") {
				$z["icon"]="<a href=javascript:tabs[0].page.event_reader('".htmlentities("lib/php/_ajax_entry.php?display=dashboard&sub=sec_event_detail&filename=null&vhost=".$r["hostname"]."&logname=".$logname."&ip=".$r["src_ip"])."&id=".$r["id"]."&sig_id=".$r["rule_id"]."');>".$z["icon"]."</a>";
			//}

			$this->data[]=array(
				"filename"	=> $z["logfile"],
				"ip"		=> $this->dec2ip($r["src_ip"]),
				"logname"	=> $logname,
				"sig_id"	=> $r["rule_id"],
				"level"		=> $r["level"],
				"timestamp"	=> date("H:i:s",$r["timestamp"]),
				"vhost"		=> $r["hostname"],
				"type"		=> $z["type"],
				"icon"		=> $z["icon"],
				"text"		=> $z["logentry"]
			);
			
		}
		$this->data=array_reverse($this->data);
		mysql_close($dbc);
	}
	
	function get_data_from_file()	{
		$fp=fopen($this->log_path.$this->log_name,"r");
		while ($line=fgets($fp,2048))	{
			//if ($this->counter>=$_SESSION["asl_last_line"])	{
			if ($this->counter>=0)	{				  
				// Get date
				$date=substr($line,9,10);
				if (is_numeric($date)===FALSE) {continue;}
				
				// Time transformations
				$time=date("H:i:s",$date);
				
				// Logfile
				$ruleid=fgets($fp,1024);
				$logname=explode("->",$ruleid);
				$logname=rtrim($logname[1]);
				
				// Get rule id
				$ruleid=fgets($fp,1024);
				$tmp=strtok($ruleid," ");
				$tmp=strtok(" ");
				$rule=$tmp;
				
				// No rule id
				if (is_numeric($rule)===FALSE) {continue;}

				// ignore test
				//if ($rule==$this->ignore) {continue;}

				// get level
				$tmp=strtok(")");
				$level=preg_replace("@\(level @","",$tmp);
				
				// get src ip
				$srcip=fgets($fp,1024);
				
				// get user
				$user=fgets($fp,2048);
				
				// get log entry
				$logentry=fgets($fp,2048);
				$logentry=rtrim($logentry);
				$logentry=preg_replace("/ \(null/","  (null",$logentry);

				// test
				//$ignore_pattern = "/.*RBL.*/";
				//if (preg_match($ignore_pattern, $logentry, $unused)) {
				// continue;
				//}

				$z=$this->parse_log($logentry,$logname,"");

				// this is only good for mod_sec data
				
				$uf=array(
					"line_no"	=> $this->counter,
					"filename"	=> $z["logfile"],
					"ip"		=> $z["client"],
					"logname"	=> $logname,
					"sig_id"	=> $rule,
					"level"		=> $level,
					"timestamp"	=> $time,
					"vhost"		=> $z["domain"],
					"type"		=> $z["type"],
					"icon"		=> $z["icon"],
					"text"		=> $z["logentry"]
				);

				$flag=1;
				// level
				if ($uf["level"]<$this->req["level"]) {$flag=0;}

				// time
				if ($this->req["time_start"]=="hh:mm[:ss]" || $this->req["time_start"]=="") {$ts_flag=0;}
				else {
					$ts_flag=1;
					$ts=strtotime(date("Y-m-d",time())." ".$this->req["time_start"]);
				}
				if ($this->req["time_end"]=="hh:mm[:ss]" || $this->req["time_end"]=="") {$te_flag=0;}
				else {
					$te_flag=1;
					$te=strtotime(date("Y-m-d",time())." ".$this->req["time_end"]);
				}
				if ($ts_flag==0 && $te_flag==1) {if ($te<strtotime($uf["timestamp"])) {$flag=0;}}
				if ($ts_flag==1 && $te_flag==1)	{if (strtotime($uf["timestamp"])<$ts || strtotime($uf["timestamp"])>$te) {$flag=0;}}
				if ($ts_flag==1 && $te_flag==0) {if (strtotime($uf["timestamp"])<$ts) {$flag=0;}}

				// domain
				if (!empty($this->req["domain"])) {
					$y=$this->validateIpAddress($this->req["domain"]);
					if ($y) {
						// test as ip
						if ($uf["ip"]!=$this->req["domain"]) {$flag=0;}
					}
					else {
						// test as host
						if (!preg_match("/(.*)(".$this->req["domain"].")(.*)/i",$uf["vhost"])) {$flag=0;}
					}
				}

				
				
				if ($flag==1) {
					$this->data_tmp[]=$uf;
				}
				$this->counter++;
			}
		}
		fclose($fp);
		//$this->trim_array();
	}

	function filter_data()	{
		$last=count($this->data_tmp)-1;
		$first=$last-48;
		if ($first<0) {$first=0;}
		$_SESSION["asl_last_line"]=$this->data_tmp[$first]["line_no"];
		
		for ($i=$first;$i<=$last;$i++) {
			$this->data[]=$this->data_tmp[$i];
		}		
	}
}
?>
