<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}



class Geoblock extends AjaxRequest {
	var $filename="/etc/asl/tld_country.txt";
	var $filename_block="/etc/asl/geo-blacklist";
		
	function init()	{
		// get current blocks
		$blocks=array();
		if ($fh=fopen($this->filename_block,"r")) {
			while ($line=fgets($fh,1024)) {
				$blocks[trim($line)]=1;
			}
			fclose($fh);
		}
		else {
			die("failed open blocks for reading");
		}
		
		$this->geoblock_tld();
		
		// get tlds
		$tld=array();
		$fh=file($this->filename);

		$this->data["blocks"]=$blocks;
		
		foreach ($fh AS $k=>$v) {
			$parts=split("\|",trim($v));
			if (isset($blocks[trim($parts[0])])) {$blocked=1;} else {$blocked=0;}
			$tld[]=array(
				"tld"		=> $parts[0],
				"name"		=> htmlentities($parts[1]),
				"blocked"	=> $blocked
			);
		}
		
		$this->data["counter"]=count($tld);
		
		// resort for 4 columns
		for ($i=0;$i<=62;$i++) {
			$this->data["tld"][]=$tld[$i];
			$this->data["tld"][]=$tld[$i+63];
			$this->data["tld"][]=$tld[$i+126];
			if (isset($tld[$i+189])) {
				$this->data["tld"][]=$tld[$i+189];
			}
			else {
				$this->data["tld"][]=array("tld"=>"empty","name"=>"empty","blocked"=>0);
			}
		}		
	}

	function geoblock_tld() {
		if (isset($this->req["geo_ip"])) {
			$out="";
			$ip=split(",",$this->req["geo_ip"]);
			if (count($ip)) {
				foreach ($ip AS $k=>$v) {
					$out.=$v."\n";
				}
			}
			if ($fh=fopen($this->filename_block,"w")) {
				fwrite($fh,$out);
				fclose($fh);
				exec ("sudo /var/asl/bin/asl --reload-firewall");
			}
			else {
				die("failed open file");
			}
		}
	}
}
?>
