<?php 
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

ob_start();

include_once("/etc/asl/web.conf");


// Temphack
$config_name = "config";
// set default config id if none specified
if (!isset($_GET["config_name"]))	{$_GET["config_name"]="config";}

$xml="<?xml version=\"1.0\" ?>\n";
$xml.="<root>\n";

if (file_exists(PATH_CONFIGS.$config_name))	{
	$lines=file(PATH_CONFIGS.$config_name);

	$xml.="\t<status>\n".
			"\t\t<code>0</code>\n".
			"\t\t<string>Configuration file (".$_GET["config_name"].") loaded.</string>\n".
			"\t\t<lines>".count($lines)."</lines>\n".
			"\t</status>\n";
	$xml.="\t<entries>\n";
	
	foreach ($lines AS $k=>$v)	{
		$v=trim($v);
		$xml.="\t\t<entry>\n";
		if (substr($v,0,1)=="#")	{
			$xml.="\t\t\t<type>header</type>\n".
				  "\t\t\t<text>".$v."</text>\n";
		}
		else if (empty($v) || ord(substr($v,0,1))==10)	{
			$xml.="\t\t\t<type>spacer</type>\n".
				  "\t\t\t<text>spacer</text>\n";
		}
		else {
			$text="";
			$parts=split("=",$v);
			$fieldname=$parts[0];
			
			if (file_exists("../help/config/".$fieldname.".txt"))	{
				$help=file_get_contents("../help/config/".$fieldname.".txt");
			}
			else	{
				$help="No help is available for this element.";
			}
			
			if (strtolower($parts[1])=="no" || strtolower($parts[1])=="yes")	{
				$type="boolean";
				if ($parts[1]=="no")	{$fieldvalue=0;}
				else					{$fieldvalue=1;}
				$xml.="\t\t\t<type>boolean</type>\n".
					  "\t\t\t<text>null</text>\n".
					  "\t\t\t<fieldname>".$fieldname."</fieldname>\n".
					  "\t\t\t<fieldvalue>".$fieldvalue."</fieldvalue>\n";
			}
			else if (substr($parts[1],0,1)==chr(34))	{
				$type="string";
				//$fieldname=$parts[0];
				$fieldvalue=str_replace(chr(34),"",$parts[1]);
				if ($fieldvalue == "" ) {
				  $fieldvalue = " ";
				}

				$xml.="\t\t\t<type>string</type>\n".
					  "\t\t\t<text>null</text>\n".
					  "\t\t\t<fieldname>".$fieldname."</fieldname>\n".
					  "\t\t\t<fieldvalue>".$fieldvalue."</fieldvalue>\n";
			}
			else	{}
			$xml.="\t\t\t<help>".htmlentities($help)."</help>\n";
		}
			
		$xml.="\t\t</entry>\n";		
	}
	$xml.="\t</entries>\n";
}
else	{
	$xml.="\t<status>\n".
			"\t\t<code>1</code>\n";
			"\t\t<string>Configuration file (".$_GET["config_name"].") not found.</string>\n".
			"\t</status>\n";
}
$xml.="</root>";
echo $xml;
ob_end_flush();
?>
