<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

class DB_VulnerabilityDetail extends AjaxRequest {
	var $file_summary="/var/asl/data/vulnerability-data";
	var $file_detail="/var/asl/data/vulnerability-report";
	
	function init() {
		$this->data=array(
			"summary"=>array(),
			"detail"=>array()
		);
	
		// summary data
		$fp=fopen($this->file_summary,"r");
		while ($line=fgets($fp,2048)) {
			$tmp=explode(' ',$line);
			$this->data["summary"][]=array(
				"text"=>$tmp[0],
				"value"=>rtrim($tmp[1])
			);
		}
		fclose($fp);
		
		// detail data
		$fp=fopen($this->file_detail,"r");
		while ($line=fgets($fp,2048)) {
			$tmp=explode(',',$line);
			if (file_exists("/var/asl/data/templates/".rtrim($tmp[1]))) {
				$fp2=fopen("/var/asl/data/templates/".rtrim($tmp[1]),"r");
				while (!feof($fp2)) {
					$cline=fgets($fp2);
					$this->data["detail"][]=array(
						"text"=>$tmp[0],
						"data"=>$cline
					);
				}
				fclose($fp2);
			}
			else {
				$this->data["detail"][]=array(
					"text"=>$tmp[0],
					"data"=>"Error:  /var/asl/data/templates/".rtrim($tmp[1])." doesn't exist."
				);
			}
		}
		fclose($fp);
	}
}
?>
